## Edition de code pour définir des contraintes spécifiques

Deux langages différents peuvent être utilisés afin de définir des contraintes spécifiques sur les jeux de données, les entités et les attributs.

La section **Code** permet d’accéder soit à un éditeur de texte pour définir des fonctions pyhton, soit au formulaire de création de fonctions fme_evaluate.

[En savoir plus sur les langages de définitions de contraintes spécifiques.](../../04-ContraintesRessources/04.LangagesDefinition.html)

### Édition de code Python

![](../../Ressources/Images/Interface_code_tcl.PNG)

Au dessus du formulaire d’édition de code Python, une barre de menus permet d’importer ou d’exporter le code à partir d’un fichier texte.

Lorsqu’une erreur de codage est implémentée sur une contrainte relative à une entité, l’erreur de codage suivante est retournée : "Erreur de codage sur l’entité". Lorsqu'une erreur de codage est implémentée sur une contraintes relative à un attribut, le message est le suivant : "Erreur de codage sur l’attribut". Une erreur de codage implémentée sur un jeu de données retourne l’erreur : "Violation de la contrainte spécifique (Python) sur le jeu de données".

<span style="color: #943a99;">==> Erreurs retournées : E0046 et E0049 (Exception python erreur de codage).</span>

<span style="color: #943a99;">==> Erreurs retournées : E0048 (Violation de la contrainte spécifique (Python) sur le jeu de données).</span>

[En savoir plus sur le code Python.](../../04-ContraintesRessources/04.LangagesDefinition.html#code-python)

### Édition de Code Fme_evaluate

![](../../Ressources/Images/Interface_code_fme.PNG)

Le formulaire de saisie du code de type fme_evaluate se présente sous la forme d’une liste des différentes fonctions utilisables. La particularité des ces fonctions est qu’ elles doivent obligatoirement être présentées sur une seule ligne et renvoyer une valeur booléenne.

<span style="color: #943a99;">==> Erreur retournée : E0035 (Non respect de la contrainte sur le type d'entité).</span>

[En savoir plus sur le code fme_evaluate.](../../04-ContraintesRessources/04.LangagesDefinition.html#fme-evaluate)
